# warp.cpp File Reference

Implementation of the "Warp" layer. More...

`#include "warp.h"`
`#include <synfig/string.h>`
`#include <synfig/time.h>`
`#include <synfig/context.h>`
`#include <synfig/paramdesc.h>`
`#include <synfig/renddesc.h>`
`#include <synfig/surface.h>`
`#include <synfig/value.h>`
`#include <synfig/valuenode.h>`
`#include <synfig/transform.h>`
`#include <ETL/misc>`

## Defines

#define | triangle_area(a, b, c) (0.5*(-b[0]*a[1]+c[0]*a[1]+a[0]*b[1]-c[0]*b[1]-a[0]*c[1]+b[0]*c[1]))
#define | quad_area(a, b, c, d) (triangle_area(a,b,c)+triangle_area(a,c,d))
#define | matrix tmp

## Functions

| SYNFIG_LAYER_INIT (Warp)
| SYNFIG_LAYER_SET_NAME (Warp,"warp")
| SYNFIG_LAYER_SET_LOCAL_NAME (Warp, N_("Warp"))
| SYNFIG_LAYER_SET_CATEGORY (Warp, N_("Distortions"))
| SYNFIG_LAYER_SET_VERSION (Warp,"0.1")
| SYNFIG_LAYER_SET_CVS_ID (Warp,"$Id$")
Real | mat3_determinant (Real matrix[3][3])
void | mat3_invert (Real in[3][3], Real out[3][3])

## Detailed Description

Implementation of the "Warp" layer.

$Id$

=== N O T E S ===========================================================

=========================================================================

## Define Documentation

#define triangle_area | ( | a,
|  | b,
|  | c |  | ) | (0.5*(-b[0]*a[1]+c[0]*a[1]+a[0]*b[1]-c[0]*b[1]-a[0]*c[1]+b[0]*c[1]))

#define quad_area | ( | a,
|  | b,
|  | c,
|  | d |  | ) | (triangle_area(a,b,c)+triangle_area(a,c,d))

#define matrix tmp

## Function Documentation

SYNFIG_LAYER_INIT | ( | Warp |  | ) |

SYNFIG_LAYER_SET_NAME | ( | Warp | ,
|  | "warp" |  |
| ) |  |  |

SYNFIG_LAYER_SET_LOCAL_NAME | ( | Warp | ,
|  | N_("Warp") |  |
| ) |  |  |

SYNFIG_LAYER_SET_CATEGORY | ( | Warp | ,
|  | N_("Distortions") |  |
| ) |  |  |

SYNFIG_LAYER_SET_VERSION | ( | Warp | ,
|  | "0.1" |  |
| ) |  |  |

SYNFIG_LAYER_SET_CVS_ID | ( | Warp | ,
|  | "$Id$" |  |
| ) |  |  |

Real mat3_determinant | ( | Real | matrix[3][3] | ) |

Referenced by mat3_invert().

void mat3_invert | ( | Real | in[3][3],
|  | Real | out[3][3] |
| ) |  |  |

References mat3_determinant().

Referenced by Warp::sync().